> ## Documentation Index
> Fetch the complete documentation index at: https://ormilabs.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Get historical balance

> Fetch the historical native, fungible (ERC-20), and non-fungible (ERC-721 & ERC-1155) tokens held by an address at a given block height or date.




## OpenAPI

````yaml get /somnia/v1/address/{walletAddress}/balance/historical
openapi: 3.0.3
info:
  description: ''
  license:
    name: Apache 2.0
    url: https://www.apache.org/licenses/LICENSE-2.0
  title: Data API
  version: 1.0.0
servers:
  - description: The DEV base URL for the API
    url: https://data-api.cloud.ormi.dev
security: []
paths:
  /somnia/v1/address/{walletAddress}/balance/historical:
    get:
      tags:
        - Balances
      summary: Get historical balance
      description: >
        Fetch the historical native, fungible (ERC-20), and non-fungible
        (ERC-721 & ERC-1155) tokens held by an address at a given block height
        or date.
      operationId: getHistoricalBalances
      parameters:
        - description: A wallet address.
          in: path
          name: walletAddress
          required: true
          schema:
            type: string
        - description: Contract address to filter by.
          in: query
          name: contract-address
          required: false
          schema:
            type: string
        - description: >-
            Ending block to define a block range. Omitting this parameter
            defaults to the latest block height.
          in: query
          name: block-height
          required: false
          schema:
            format: int64
            type: integer
        - description: >-
            Ending date to define a block range (YYYY-MM-DD). Omitting this
            parameter defaults to the current date.
          in: query
          name: date
          required: false
          schema:
            format: date
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HistoricalBalance'
          description: OK
components:
  schemas:
    HistoricalBalance:
      properties:
        address:
          type: string
        items:
          items:
            $ref: '#/components/schemas/HistoricalBalanceItems'
          type: array
        updated_at:
          format: date-time
          type: string
      required:
        - address
        - updated_at
        - items
      type: object
    HistoricalBalanceItems:
      properties:
        balance:
          type: string
        block_height:
          format: int64
          type: integer
        contract_address:
          nullable: true
          type: string
        contract_decimals:
          nullable: true
          type: integer
        contract_name:
          nullable: true
          type: string
        erc_type:
          nullable: true
          type: string
        is_native:
          type: boolean
        last_transferred_at:
          format: date-time
          type: string
        last_transferred_block_height:
          format: int64
          type: integer
      required:
        - block_height
        - last_transferred_block_height
        - last_transferred_at
        - native_token
        - balance

````